class_name Iterator extends RefCounted

func clone() -> Iterator:
    return Iterator.new()

func next() -> Option:
    return Option.none

func into_peekable() -> PeekableIter:
    return PeekableIter.new(self)

func into_indexed() -> IndexedIterator:
    return IndexedIterator.new(self)

func _iter_init(iter: Array) -> bool:
    return _iter_next(iter)

func _iter_next(iter: Array) -> bool:
    iter[0] = next()
    return iter[0].is_some()

func _iter_get(iter: Variant) -> Variant:
    return iter.unwrap()
